###################################################################
# GTChat 0.95 Alpha Plugin #
# Written for release 20021225 #
# Author: Wladimir Palant #
# #
# This plugin manages the file Settings.dat. #
###################################################################
package GTChat::Plugins::Administration::Settings::095_01;
use strict;
return bless({
 action_handlers => {
 'admin_banlist' => \&handler2,
 },
 template_var_handlers => {
 'bannedlist' => \&handler,
 },
});
sub handler
{
 my($self,$main) = @_;
 $main->open(local* FILE, $main->translateName('vardir::banlist.txt')) || $main->fatal_error('couldnotopen',{file => $main->translateName('vardir::banlist.txt')});
 my @list=<FILE>;
 $main->close(*FILE);
 my @users=();
 my $user;
 my $count=0;
 foreach (@list)
 {
 $count++;
 $_ =~ s/[\n\r]//g;
 my ($host,$ip,$forwardedfor,$time,$reason,$name,$nick) = split(/\|/,$_);
 my $tag = "GETDATETIME";
 my($type) = ($tag =~ /^GET(?:STD)?(.*)/);
 my $datetime = getTimeText($main, lc($type), $time);
 my $url = $main->{settings}{urls}{chaturl};
 $user->{count} = "<td width=1%>$count.</td>\n";
 $user->{nick} = "<td width=1%>$nick</td>\n";
 $user->{name} = "<td width=1%>$name</td>\n";
 $user->{ip} = "<td width=1%>$ip</td>\n";
 $user->{host} = "<td width=1%>$host</td>\n";
 $user->{time} = "<td width=1%>$datetime</td>\n";
 $user->{reason} = "<td width=1%>$reason</td>\n";
 $user->{unlock} = '<td width=1%><a href="'.$url.'?&action=admin_banlist&nickname='.$nick.'">Unban '.$nick.'</a></td>';
 push @users, join('', $user->{count},$user->{nick}, $user->{name}, $user->{ip}, $user->{host}, $user->{time}, $user->{reason}, $user->{unlock}) . "\n";;
 last if($count == $main->{input}{nr});
 }
 $main->{template_vars}{bannedlist} = \@users;
}
sub handler2
{
 my($self,$main) = @_;
my $nick = $main->{input}{user};
 $main->open(local *FILE,'+>>'.$main->translateName('vardir::banlist.txt')) || $main->fatal_error('couldnotopen',{file => $main->translateName('vardir::banlist.txt')});
 seek(FILE,0,0);
 my @users=<FILE>;
 my $min = 0;
 my $max = $#users;
 while ($min <= $max)
 {
 my $curindex = int(($min+$max)/2);
 my ($curhost,$curip,$curforwardedfor,$curtime,$curreason,$curname,$curnick) = split(/\|/,$users[$curindex]);
 $curnick =~ s/[\n]//g;
 my $result = $curnick cmp $nick;
 if ($result == 0)
 {
 splice(@users,$curindex,1);
 last;
 }
 elsif ($result < 0)
 {
 $min = $curindex + 1;
 }
 else
 {
 $max = $curindex - 1;
 }
 }
 if ($min > $max)
 {
 $main->close(*FILE);
 my $output = $main->createErrorOutput('unlock_notfound',{nick => $nick,});
 return [$output->restrictToCurrentUser];
 }
 seek(FILE,0,0);
 truncate(FILE,0);
 print FILE foreach @users;
 $main->close(*FILE);
 $main->printTemplate('admin/banlist');
}
sub getTimeText
{
 my($main,$type,$time) = @_;
 my @time;
 if ($time =~ /\./)
 {
 @time = (0,0,0,split(/\./,$time));
 }
 else
 {
 @time = localtime($time);
 $time[4]++;
 $time[5]+=1900;
 }
 my $mask = $main->{current_language}{$type.'format'};
 my $values = $main->{current_language}{$type.'values'};
 return sprintf($mask,@time[@$values]);
}
