#########################################################
#					     								#
# - German.lng Editor						     		#
# - Group Manager										#
#					     								#
# Addon Copyright 2007 by TrioxX and Spiltcoffee 		#
#														#
# Originally written for GTChat 0.97					#
#					     								#
# Dieses Addon darf ausschlielich NUR auf   			#
# http://www.gtchatforum.de sowie	     				#
# http://www.gtchat.org zum Download angeboten werden.  #
#														#
# Der Addon Ersteller haftet nicht fr eventuell		#
# enstandene Schden an der Chatsoftware.				#
#														#
#  This plugin manage the languagefile on ACP           #
#########################################################
package GTChat::Plugins::Administration::Language::097_01;
use strict;

return bless({
	action_handlers => {
		'admin_infomsg' => \&messages_handler,
		'admin_errormsg' => \&messages_handler,
		'admin_groups' => \&group_handler,
	},
	template_var_handlers => {
		'admin_infomsg' => \&messages_loader,
		'admin_errormsg' => \&messages_loader,
		'admin_groups' => \&group_loader,
	},
});

sub saveArray
{
	my ($file, $array, $level) = @_;

	$level = 1 unless $level;

	print $file "[\n";
	foreach my $element (@$array)
	{
		print $file "\t"x$level;

		if (ref($element) eq 'HASH')
		{
			saveHash($file, $element, $level+1);
		}
		elsif (ref($element) eq 'ARRAY')
		{
			saveArray($file, $element, $level+1);
		}
		else
		{
			my $str = "$element";
			if ($str !~ /^(?:-?[1-9]\d*|0|-0(?=\.))(?:\.\d*[1-9])?$/)
			{
				$str =~ s/(['\\])/\\$1/g;
				$str = "'$str'";
			}
			print $file $str;
		}

		print $file ",\n";
	}
	print $file "\t"x($level-1) . "]";
}

sub saveHash
{
	my ($file, $hash, $level) = @_;

	$level = 1 unless $level;

	print $file "{\n";
	foreach my $key (sort keys %$hash)
	{
		my $str = $key;
		if ($str =~ /\W/ || $str eq '')
		{
			$str =~ s/(['\\])/\\$1/g;
			$str = "'$str'";
		}

		print $file "\t"x$level . $str . ' => ';

		if (ref($hash->{$key}) eq 'HASH')
		{
			saveHash($file, $hash->{$key}, $level+1);
		}
		elsif (ref($hash->{$key}) eq 'ARRAY')
		{
			saveArray($file, $hash->{$key}, $level+1);
		}
		else
		{
			$str = "$hash->{$key}";
			if ($str !~ /^(?:-?[1-9]\d*|0|-0(?=\.))(?:\.\d*[1-9])?$/)
			{
				$str =~ s/(['\\])/\\$1/g;
				$str = "'$str'";
			}
			print $file $str;
		}

		print $file ",\n";
	}
	print $file "\t"x($level-1) . "}";
}

sub saveLanguage
{
	my ($main, $language) = @_;

	$main->open(local *FILE, '>'.$language->{filename});
	print FILE <<"EOT";
##########################################################
#  This is an autogenerated file. Do not change anything #
#  unless you know exactly what you do. Use the Admin    #
#  functions menu instead.                               #
##########################################################

return
EOT

	saveHash(*FILE, $language);

	print FILE ";";

	$main->close(*FILE);
}

sub messages_handler
{
	my($self,$main) = @_;

	$main->{template_vars}{backaddr} = 'javascript:top.setTimeout(\'writeMenu()\',0)';
	$main->fatal_error('nopermission') unless $main->hasPermission('admin_messages');

	my %messages = ();
	my $type = ($main->{input}{type} =~ /info/ ? 'info' : 'error');
	my $language = $main->{modules}{$main->{settings}{default}{language}.'.lng'};

	foreach my $key (sort keys %{$language->{messages}})
	{
		if ($key !~ /^$type/)
		{
			$messages{$key} = $language->{messages}{$key};
		}
	}

	foreach my $key (sort keys %{$main->{input}})
	{
		if ($key =~ /^$type/)
		{
			$messages{$key} = $main->{input}{$key};
			$messages{$key} =~ s/([^{\\}])'/$1\'/g;
		}
	}

	$language->{messages} = \%messages;

	saveLanguage($main,$language);

	$main->printTemplate('admin/menu_back');
}

sub messages_loader
{
	my($self,$main,$var) = @_;

	$main->{template_vars}{backaddr} = 'javascript:top.setTimeout(\'writeMenu()\',0)';
	$main->fatal_error('nopermission') unless $main->hasPermission('admin_messages');

	my $type = ($var =~ /info/ ? 'info' : 'error');
	my @ret = ();
	my $language = $main->{modules}{$main->{settings}{default}{language}.'.lng'};
	my $count = 0;
	foreach my $key (sort keys %{$language->{messages}})
	{
		if ($key =~ /^$type/)
		{
			$ret[$count]{name} = $key;
			$ret[$count]{value} = $language->{messages}{$key};
			$ret[$count]{value} =~ s/"/\"/g;
			$count++;
		}
	}
	$main->{template_vars}{"admin_".$type."msg"} = \@ret;
}

sub group_handler
{
	my($self,$main) = @_;

	$main->{template_vars}{backaddr} = 'javascript:top.setTimeout(\'writeMenu()\',0)';
	$main->fatal_error('nopermission') unless $main->hasPermission('admin_groupnames');

	my @names = ();
	my @tags = ();
	my $language = $main->{modules}{$main->{settings}{default}{language}.'.lng'};

	foreach my $key (sort keys %{$main->{input}})
	{
		if ($key =~ s/^name//)
		{
			$names[$key+2] = $main->{input}{"name$key"};
			$names[$key+2] =~ s/([^{\\}])'/$1\'/g;
		}
		if ($key =~ s/^tag//)
		{
			$tags[$key+2] = $main->{input}{"tag$key"};
			$tags[$key+2] =~ s/([^{\\}])'/$1\'/g;
		}
	}

	$language->{group_names} = \@names;
	$language->{group_tags} = \@tags;

	saveLanguage($main,$language);

	$main->printTemplate('admin/menu_back');
}

sub group_loader
{
	my($self,$main,$var) = @_;

	$main->{template_vars}{backaddr} = 'javascript:top.setTimeout(\'writeMenu()\',0)';
	$main->fatal_error('nopermission') unless $main->hasPermission('admin_groupnames');

	my @ret = ();
	my $language = $main->{modules}{$main->{settings}{default}{language}.'.lng'};
	my $count = 0;

	for (my($i)=0;$i<13;$i++)
	{
		$ret[$count]{name} = $language->{group_names}[$count];
		$ret[$count]{tag} = $language->{group_tags}[$count];
		$ret[$count]{no} = $count-2;
		$count++;
	}

	$main->{template_vars}{admin_groups} = \@ret;
}