                                   #
#  Written for release 20021101                                   #
#  Author: Wladimir Palant                                        #
#                                                                 #
#  This plugin provides the chat commands /me, /broadcast, /img,  #
#  /away and the default command (plain text).                    #
###################################################################

package GTChat::Plugins::TextCommands::095_01;
use strict;

return bless({
        command_handlers => {
            '' => \&text_handler,
		'admin' => \&text_handler,
		'me' => \&custom_handler,
		'broadcast' => \&custom_handler,
		'img' => \&custom_handler,
		'away' => \&away_handler,
                 'sound' => \&custom_handler,
                 'bsay' => \&custom_handler,
                 'bdo' => \&custom_handler,
                 'badmin' => \&custom_handler,
                 'callop' => \&custom_handler,
                 'sound' => \&custom_handler,
        },
});


sub check_gagged
{
        my $main = shift;

        if (exists($main->{current_user}{gagtime}) && $main->{runtime}{now} < $main->{current_user}{gagtime})
        {
                return [$main->createErrorOutput('gagged',{seconds => $main->{current_user}{gagtime}-$main->{runtime}{now}})];
        }
        return undef;
}

sub text_handler
{
        my($self,$main,$command,$text,$answer,$witz,$error) = @_;

        my @ret=();

        if (my $error=check_gagged($main))
        {
                return $error;
        }
        if ($main->{current_user}{away})
        {
                $main->{current_user}{away} = 0;

                my $output = $main->createInfoOutput('awayoff',{nick => $main->{current_user}{nick}});
                push @ret, $output->restrictToUser->restrictToCurrentRoom->setChangedAttributes('away');
        }

        my @to=();

        my @words = split(/\s/,$text);
        my $changed = 0;
        my $i=$#words;
        while ($i>=0 && $words[$i] =~ /^\@[^@]+$/)
        {
                $i--;
        }
        unshift(@words,splice(@words,$i+1));

        while ($words[0] =~ /^[^:]+:$/ || $words[0] =~ /^\@[^@]+$/)
        {
                $words[0] =~ s/\:$//;
                $words[0] =~ s/^\@//;

                my $candidates = $main->getPossibleOnlineUsers($words[0],$main->{current_user}{room});
                if ($#$candidates<0)
                {
                        push @ret,$main->createErrorOutput('notinroom',{nick => $words[0]});
                }
                elsif ($#$candidates>0)
                {
                        push @ret,$main->createErrorOutput('ambiguousname',{nick => $words[0]});
                }
                else
                {
                        push @to, $candidates->[0]{nick};
                        $changed = 1;
                }
                shift(@words);
        }
        $text=join(' ',@words) if ($changed);
        if ($text ne "")
        {
if ($text =~ /hh/ or $text =~ /88/ or $text =~ /heilhitler/ or $text =~ /heil hitler/ or $text =~ /sieg heil/)
{
$text = 'Scheint die Sonne auch fr Nazis- Wenns nach mir geht tut sies nicht!';
}
if ($text =~ /Butler/ or $text =~ /Butler/)
        {
$text = $text;
my $output1 = $main->createOutput(
                                {
                                        template => 'text',
                                        color => $main->{current_user}{color},
                                        nick => $main->{current_user}{nick},
                                        text => $text,
                                });
        $output1->restrictToCurrentRoom;
if ($text =~ /\bwie\b/i and $text =~ /\bgehts\b/i)
        {
$answer = 'Schn, das auch mal einer fragt, mir geht es sehr gut.';
}
elsif ($text =~ /\bwer\b/i && $text =~ /\bbist\b/i || $text =~ /\bwie\b/i and $text =~ /\bheit\b/i)
{
$answer = 'Ich bin hier nur der Bot, Butler mein Name.';
}
elsif ($text =~ /\bHallo\b/i)
{
my $output = $main->createInfoOutput('bot_hallo',
{
nick => $main->{current_user}{nick},
});
return [$output->restrictToCurrentUser];
}
elsif ($text =~ /\bBackdraft\b/i)
{
$answer = 'Backdraft ist mein Schaffer :D';
}
elsif ($text =~ /\bthx\b/i)
{
$answer = 'Bitte, bitte, gern geschehen! Darf es sonst noch etwas sein?';
}
elsif ($text =~ /\bdanke\b/i)
{
$answer = 'Bitte, bitte, gern geschehen! Darf es sonst noch etwas sein?';
}
elsif ($text =~ /\bsauren\b/i)
{
$answer = '+Verteilt an alle ein eiskalten Sauren+';
}
elsif ($text =~ /\bier\b/i)
{
$answer = '+serviert allen ein eiskaltes Bier+';
}
elsif ($text =~ /\bschwul\b/i || $text =~ /\bhomo\b/i)
{
$answer = 'Ich habe nichts gegen Homosexuelle.';
}
elsif ($text =~ /\bsex\b/i)
{
$answer = 'Aha so genau wollte ich es auch nicht wissen...';
}
elsif ($text =~ /\bhilfe\b/i)
{
$answer = 'Versuche es doch einmal mit /h, ansonsten kann ich dir nur sagen: /m Badelehrling';
}
elsif ($text =~ /\bWitz\b/i)
{
$witz = rand 10;
$witz =~ s/\.//g;
$witz = substr($witz, 1, 1);
$answer = $witz;
if ($witz == 0)
{
$answer = '2 Alte Frauen laufen ber eine Strate, als die eine schon ankommt ruft sie: ""Agathe, Agathe komm doch schnell da kommt ein LKWh...""';
}
elsif ($witz == 1)
{
$answer = 'Der Mann ist bei der Wahrsagerin, _Die Wahrsagerin:_ oh, ich sehe Sie sind der Vater von 2 Kindern. Darauf der _Mann:_ Nein, das denken Sie nur, ich bin der Vater von _3_ Kindern! Darauf _sie:_ Nein, das denken Sie...';
}
elsif ($witz == 2)
{
$answer = 'Zwei Tomaten laufen ber die Strae, da sagt die eine: Hallo Frau Tomate, Dann kommt ein Auto und fhrt sie platt. Darauf die andere: Hallo Frau Ketchup!';
}
elsif ($witz == 3)
{
$answer = 'Was haben Lehrer und Wolken gemeinsam?Wenn sie sich verziehen kann es ein schner Tag werden :-) .';
}
elsif ($witz == 4)
{
$answer = 'Was sagt die Mutter zu ihrem Kind nach seinem tdlichen Sturz? Keine Sorge schatz, passiert dir nie wieder.';
}
elsif ($witz == 5)
{
$answer = '""Papi leihst du mir heute Abend dein Auto?"" ""Ich denke garnicht erst daran!"" ""Aber ich bin doch nun alt genug!"" ""Ja du schon aber das Auto nicht..""';
}
elsif ($witz == 6)
{
$answer = 'Warum wurde der Magnethandschuh erfunden? Damit die Mantafahrer auch bei 180 die Hand auf dem Dach halten knnen.';
}
elsif ($witz == 7)
{
$answer = 'Was geht einem Mantafahrer durch den Kopf wenn er mit 180km/h gegen die Wand fhrt? Der Heckspoiler.';
}
elsif ($witz == 8)
{
$answer = 'Witz8';
}
elsif ($witz == 9)
{
$answer = 'Witz9';
}
elsif ($witz == 10)
{
$answer = 'Witz10';
}
}
elsif ($text =~ /\bknuddel\b/i)
{
$answer = 'Wer bettelt der verzweifelt.';
}
elsif ($text =~ /\bliebe\b/i)
{
$answer = 'Ich bleibe Frolina immer treu!';
}
elsif ($text =~ /\bpimpern\b/i or $text =~ /\bPimpern\b/i)
{
$answer = 'Nix da mein Arsch gehrt mir!';
}
elsif ($text =~ /\blol\b/i || $text =~ /\brofl\b/i || $text =~ /\bxD\b/i)
{
$answer = 'Was gibts denn da zu lachen?';
}
else
{
$error = rand 20;
$error =~ s/\.//g;
$error = substr($error, 1, 1);
if ($error == 0)
{
$answer = 'Ich glaube gestern stand davon etwas in der Zeitung.';
}
if ($error == 1)
{
$answer = 'Davon habe ich noch nie gehrt.';
}
if ($error == 2)
{
$answer = 'Ja, ber dieses Thema las ich einst ein Buch...';
}
if ($error == 3)
{
$answer = 'Knntest du mir das bitte einmal genauer erklren?';
}
if ($error == 4)
{
$answer = 'Sehr schn..sehr schn...';
}
if ($error == 5)
{
$answer = 'Was? das kann ja wohl nicht wahr sein!';
}
if ($error == 6)
{
$answer = 'Ja da muss ich dir recht geben.';
}
if ($error == 7)
{
$answer = 'Welch Euphorie.';
}
if ($error == 8)
{
$answer = 'Du bist aber ein schlauer Mensch!';
}
if ($error == 9)
{
$answer = 'Meine Mutter hat mir das einmal gesagt';
}
if ($error == 10)
{
$answer = 'Leck mich!';
}
if ($error == 11)
{
$answer = 'Warum?!';
}
if ($error == 12)
{
$answer = 'Ja das musste ja schon immer mal gesagt werden.';
}
if ($error == 13)
{
$answer = 'Wie bitte?';
}
if ($error == 14)
{
$answer = 'Kannst du dich nicht klarer ausdrcken?';
}
if ($error == 15)
{
$answer = 'Ja warten Sie bis ich das Linux06 erzhle...';
}
if ($error == 16)
{
$answer = 'Soll das jetzt etwa lustig sein oder was?';
}if ($error == 17)
{
$answer = 'Das sagte meine Gromutter bereits.';
}
if ($error == 18)
{
$answer = 'Der Job eines Bots kann ja so anstrengend sein.';
}
if ($error == 19)
{
$answer = 'Ja das bin ich';
}
}
        my $output2 = $main->createOutput(
                                {
                                        template => 'text',
                                        color => $main->{settings}{default}{color},
                                        nick => 'Butler',
                                        text => $answer,
                                });
        $output2->restrictToCurrentRoom;

        return [$output1,$output2];
}
if ($text =~ /butler/ or $text =~ /butler/)
        {
                $text = $text;
my $output1 = $main->createOutput(
                                {
                                        template => 'text',
                                        color => $main->{current_user}{color},
                                        nick => $main->{current_user}{nick},
                                        text => $text,
                                });
        $output1->restrictToCurrentRoom;
if ($text =~ /\bwie\b/i and $text =~ /\bgehts\b/i)
        {
$answer = 'Schn, das auch mal einer fragt, mir geht es sehr gut.';
}
elsif ($text =~ /\bwer\b/i && $text =~ /\bbist\b/i || $text =~ /\bwie\b/i and $text =~ /\bheit\b/i)
{
$answer = 'Ich bin hier nur der Bot, Bot mein Name.';
}
elsif ($text =~ /\bHallo\b/i)
{
my $output = $main->createInfoOutput('bot_hallo',
{
nick => $main->{current_user}{nick},
});
return [$output->restrictToCurrentUser];
}
elsif ($text =~ /\bArsch\b/i)
{
$answer = 'Bitte unterlasse diese Beleidigungen!';
}
elsif ($text =~ /\bder_papst_ist_atheist\b/i)
{
$answer = 'Oh, er ist ein netter Admin ;)';
}
elsif ($text =~ /\bBackdraft\b/i)
{
$answer = 'Backdraft ist mein Schaffer :D';
}
elsif ($text =~ /\bsauren\b/i)
{
$answer = 'Verteilt an alle einen eiskalten sauren Likr';
}
elsif ($text =~ /\bbier\b/i)
{
$answer = 'serviert allen ein khles Bier!';
}
elsif ($text =~ /\bbeer\b/i)
{
$answer = 'serviert allen ein khles Bier!';
}
elsif ($text =~ /\bcola\b/i)
{
$answer = 'serviert allen eine eiskalte Cola!';
}
elsif ($text =~ /\bkornbrause\b/i)
{
$answer = 'serviert allen ein Brausettchen und einen Korn.';
}
elsif ($text =~ /\bAdmin\b/i)
{
$answer = 'Ein wirklich guter Admin!';
}
elsif ($text =~ /\bSchule\b/i)
{
$answer = 'Hurra, hurra, die Schule brennt!';
}
elsif ($text =~ /\bbrause\b/i)
{
$answer = 'serviert allen eine leckere Brause.';
}
elsif ($text =~ /\barschloch\b/i)
{
$answer = 'Arschloch steht umgangssprachlich fr den Anus. Das Wort wird hauptschlich als Schimpfwort gebraucht. Um die Wirkung abzumildern, werden in der Umgangssprache auch Euphemismen wie Armleuchter eingesetzt.';
}
elsif ($text =~ /\bschwul\b/i || $text =~ /\bhomo\b/i)
{
$answer = 'Ich habe nichts gegen Homosexuelle.';
}
elsif ($text =~ /\bsex\b/i)
{
$answer = 'Aha so genau wollte ich es auch nicht wissen...';
}
elsif ($text =~ /\bhilfe\b/i)
{
$answer = 'Versuche es doch einmal mit /h, ansonsten kann ich dir nur sagen: /m Badelehrling';
}
elsif ($text =~ /\bWitz\b/i)
{
$witz = rand 10;
$witz =~ s/\.//g;
$witz = substr($witz, 1, 1);
$answer = $witz;
if ($witz == 0)
{
$answer = '2 Alte Frauen laufen ber eine Strate, als die eine schon ankommt ruft sie: ""Agathe, Agathe komm doch schnell da kommt ein LKWh...""';
}
elsif ($witz == 1)
{
$answer = 'Der Mann ist bei der Wahrsagerin, _Die Wahrsagerin:_ oh, ich sehe Sie sind der Vater von 2 Kindern. Darauf der _Mann:_ Nein, das denken Sie nur, ich bin der Vater von _3_ Kindern! Darauf _sie:_ Nein, das denken Sie...';
}
elsif ($witz == 2)
{
$answer = 'Zwei Tomaten laufen ber die Strae, da sagt die eine: Hallo Frau Tomate, Dann kommt ein Auto und fhrt sie platt. Darauf die andere: Hallo Frau Ketchup!';
}
elsif ($witz == 3)
{
$answer = 'Was haben Lehrer und Wolken gemeinsam?Wenn sie sich verziehen kann es ein schner Tag werden :-) .';
}
elsif ($witz == 4)
{
$answer = 'Was sagt die Mutter zu ihrem Kind nach seinem tdlichen Sturz? Keine Sorge schatz, passiert dir nie wieder.';
}
elsif ($witz == 5)
{
$answer = '""Papi leihst du mir heute Abend dein Auto?"" ""Ich denke garnicht erst daran!"" ""Aber ich bin doch nun alt genug!"" ""Ja du schon aber das Auto nicht..""';
}
elsif ($witz == 6)
{
$answer = 'Warum wurde der Magnethandschuh erfunden? Damit die Mantafahrer auch bei 180 die Hand auf dem Dach halten knnen.';
}
elsif ($witz == 7)
{
$answer = 'Was geht einem Mantafahrer durch den Kopf wenn er mit 180km/h gegen die Wand fhrt? Der Heckspoiler.';
}
elsif ($witz == 8)
{
$answer = 'Witz8';
}
elsif ($witz == 9)
{
$answer = 'Witz9';
}
elsif ($witz == 10)
{
$answer = 'Witz10';
}
}
elsif ($text =~ /\bknuddel\b/i)
{
$answer = 'Wer bettelt der verzweifelt.';
}
elsif ($text =~ /\bliebe\b/i)
{
$answer = 'Ich bleibe Frolina immer treu!';
}
elsif ($text =~ /\bpimpern\b/i or $text =~ /\bPimpern\b/i)
{
$answer = 'Nix da mein Arsch gehrt mir!';
}
elsif ($text =~ /\blol\b/i || $text =~ /\brofl\b/i || $text =~ /\bxD\b/i)
{
$answer = 'Was gibts denn da zu lachen?';
}
else
{
$error = rand 20;
$error =~ s/\.//g;
$error = substr($error, 1, 1);
if ($error == 0)
{
$answer = 'Ich glaube gestern stand davon etwas in der Zeitung.';
}
if ($error == 1)
{
$answer = 'Davon habe ich noch nie gehrt.';
}
if ($error == 2)
{
$answer = 'Ja, ber dieses Thema las ich einst ein Buch...';
}
if ($error == 3)
{
$answer = 'Knntest du mir das bitte einmal genauer erklren?';
}
if ($error == 4)
{
$answer = 'Sehr schn..sehr schn...';
}
if ($error == 5)
{
$answer = 'Was? das kann ja wohl nicht wahr sein!';
}
if ($error == 6)
{
$answer = 'Ja da muss ich dir recht geben.';
}
if ($error == 7)
{
$answer = 'Welch Euphorie.';
}
if ($error == 8)
{
$answer = 'Du bist aber ein schlauer Mensch!';
}
if ($error == 9)
{
$answer = 'Meine Mutter hat mir das einmal gesagt';
}
if ($error == 10)
{
$answer = 'Fick dich!';
}
if ($error == 11)
{
$answer = 'Warum?!';
}
if ($error == 12)
{
$answer = 'Ja das musste ja schon immer mal gesagt werden.';
}
if ($error == 13)
{
$answer = 'Wie bitte?';
}
if ($error == 14)
{
$answer = 'Kannst du dich nicht klarer ausdrcken?';
}
if ($error == 15)
{
$answer = 'Ja warten Sie bis ich das Linux06 erzhle...';
}
if ($error == 16)
{
$answer = 'Soll das jetzt etwa lustig sein oder was?';
}if ($error == 17)
{
$answer = 'Das sagte meine Gromutter bereits.';
}
if ($error == 18)
{
$answer = 'Der Job eines Bots kann ja so anstrengend sein.';
}
if ($error == 19)
{
$answer = 'Ja das bin ich';
}
}
        my $output2 = $main->createOutput(
                                {
                                        template => 'text',
                                        color => $main->{settings}{default}{color},
                                        nick => 'Butler',
                                        text => $answer,
                                });
        $output2->restrictToCurrentRoom;

        return [$output1,$output2];
}

my $output = $main->createOutput(
				{
					template => $command eq ''?'text':'admin',
					name => $main->{current_user}{name},
					nick => $main->{current_user}{nick},
					color => $main->{current_user}{color},
					text => $main->toHTML($text),
					'*' => \@to,
				});
		push @ret,$output->restrictToCurrentRoom;
	}

	return \@ret;
}

sub away_handler
{
	my($self,$main,$command,$text) = @_;

	my @ret=();

	if (my $error=check_gagged($main))
	{
		return $error;
	}
	elsif ($text eq "")
	{
		$main->{current_user}{away}=1;

		my $output = $main->createInfoOutput('awayon',{nick => $main->{current_user}{nick}});
		push @ret, $output->restrictToUser->restrictToCurrentRoom->setChangedAttributes('away');
	}
	else
	{
		$text = $main->toHTML($text);
		$main->{current_user}{away}=$text;

		my $output = $main->createInfoOutput('awayon_reason!',{nick => $main->{current_user}{nick}, reason => $text});
		push @ret, $output->restrictToUser->restrictToCurrentRoom->setChangedAttributes('away');
	}

	return \@ret;
}

sub custom_handler
{
	my($self,$main,$command,$text) = @_;

	my @ret=();

	if (my $error=check_gagged($main))
	{
		return $error;
	}

	if ($main->{current_user}{away})
	{
		$main->{current_user}{away} = 0;

		my $output = $main->createInfoOutput('awayoff',{nick => $main->{current_user}{nick}});
		push @ret, $output->restrictToUser->restrictToCurrentRoom->setChangedAttributes('away');
	}

	if ($text ne '')
	{
		my $output = $main->createOutput(
				{
					template => $command,
					name => $main->{current_user}{name},
					nick => $main->{current_user}{nick},
					color => $main->{current_user}{color},
					text => $main->toHTML($text),
				});
		$output->restrictToCurrentRoom if $command ne 'broadcast' && $command ne 'callop';
		push @ret,$output;
	}

	return \@ret;
}