################################################################################
#                                                                              #
#  Hearts.pm 0.95a40115                                                        #
#                                                                              #
#  GTChat 0.95 Alpha Plugin                                                    #
#  Written for release 20040112                                                #
#  Author: Norman Rath                                                         #
#  E-Mail: Norman.Rath@o2online.de                                             #
#                                                                              #
#  Send a heart to your friend                                                 #
#                                                                              #
################################################################################

package GTChat::Plugins::Hearts;
use strict;

bless({
	template_var_handlers => {
		'hearts' => \&handlerHeartsProfil,
		'hearts_send' => \&handlerHeartsSend,
	},
});

sub handlerHeartsSend
{
	my($self,$main) = @_;

	my $user = $main->loadUser($main->{input}{username});

	my $existsuser;

	foreach (split(/\|/,$user->{hearts}))
	{
		if($_ eq $main->{current_user}{name})
		{
			$existsuser = 1;
			last;
		}
	}

	return [$main->{template_vars}{hearts_send} = 3] if($existsuser);

	if(($main->{runtime}{now} - $main->{current_user}{lastsendhearts}) < 604800)
	{
		$main->{template_vars}{hearts_send} = 1;
		return [$main->{template_vars}{hearts_days} = sprintf "%.1f",((604800 - ($main->{runtime}{now} - $main->{current_user}{lastsendhearts})) / 86400)];
	}

	### START PointSystem.pm-Zugehrigkeit ###
	if($main->{current_user}{group} < 1 && $main->{current_user}{points} < 300)
	{
		$main->{template_vars}{hearts_send} = 2;
		return [$main->{template_vars}{hearts_points} = sprintf "%.1f",(333 - $main->{current_user}{points})];
	}


	### ENDE PointSystem.pm-Zugehrigkeit ###

	$main->{current_user}{lastsendhearts} = $main->{runtime}{now};
	$main->saveUser($main->{current_user});

	if($user->{hearts})
	{
		$user->{hearts} = $user->{hearts}."|".$main->{current_user}{name};
	}
	else
	{
		$user->{hearts} = $main->{current_user}{name};
	}

	$main->saveUser($user);

	$main->{template_vars}{hearts_send} = 0;
}

sub handlerHeartsProfil
{
	my($self,$main) = @_;

	my $user = $main->loadUser($main->{input}{username});

	my @ret=();

	foreach (split(/\|/,$user->{hearts}))
	{
		$user = $main->loadUser($_);
		push @ret, $user->{nick};
	}

	$main->{template_vars}{hearts} = \@ret;
}
