###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 07-08-2007                                   #
#  Author: burli001                                          #
#  E-Mail: burli001@gmx.net                                #
#                                                                 #
#  This plugin provides the command /ban, /unban  #
###################################################################

package GTChat::Plugins::Ban;
use strict;

return bless({
        command_handlers => {
                'ban' => \&commandHandler,
                'unban' => \&unban_handler,
        },
});

sub commandHandler
{
        my($self,$main,$command,$text) = @_;

   my(@parts) = split(/:/,$text);
        my $nick = shift @parts;
        my $time = shift @parts;
        my $tas = shift @parts;
        my $reason = join(':',@parts);
  return [$main->createErrorOutput('banaddfrage')] unless defined($nick);
    my $candidates = $main->getPossibleUsernames($nick);
          my $user = $main->loadUser($candidates->[0]);
return [$main->createErrorOutput('banadd_self',{nick => $user->{nick}})] if ($user->{name} eq $main->{current_user}{name});
    $main->fatal_error('ambiguousname',{nick => $nick}) if ($#$candidates>1);
    $main->fatal_error('unknownname',{nick => $nick}) if ($#$candidates<0);

    if($command eq 'ban')
    {
        my $candidates = $main->getPossibleOnlineUsers($nick);
        if($#$candidates == 0)
        {
            return [$main->createErrorOutput($command.'_nopermission',{nick => $user->{nick}})] if ($main->{current_user}{tempgroup} <= $user->{tempgroup});
            return [$main->createErrorOutput($command.'_admin',{nick => $user->{nick}})] if ($user->{group} >= $main->{current_user}{tempgroup});
        }
        else
        {
            return [$main->createErrorOutput($command.'_nopermission',{nick => $user->{nick}})] if ($main->{current_user}{tempgroup} <= $user->{group});
            return [$main->createErrorOutput($command.'_admin',{nick => $user->{nick}})] if ($user->{group} >= $main->{current_user}{tempgroup});
        }
if(!$time)
{
return [$main->createErrorOutput('notimes')];
}
if(!$tas)
{
return [$main->createErrorOutput('tas')];
}
if(!$reason)
{
return [$main->createErrorOutput('nogrund')];
}
           my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat,
    $Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time);
$Monat+=1;
$Jahrestag+=1;
$Monat = $Monat < 10 ? $Monat = "0".$Monat : $Monat;
$Monatstag = $Monatstag < 10 ? $Monatstag = "0".$Monatstag : $Monatstag;
$Jahr+=1900;
my $datum = "$Monatstag.$Monat.$Jahr";
$main->kickUser($user);
    $main->loadUser($user->{nick},$user);
    $user->{ban} = 1;
    $user->{ban_grund} = $reason;
    $user->{ban_admin} = $main->{current_user}{nick};
    $user->{ban_date} = $datum;
my $taz = '';
my $lng = '';
if($tas eq 'd' or $tas eq 'day' or $tas eq 'tag' or $tas eq 'tage' or $tas eq 'WARNd' or $tas eq 'WARNday' or $tas eq 'WARNtag' or $tas eq 'WARNtage')
{
$lng = " und $user->{nick}'s IP Adresse";
    $user->{bis_bantime} = $main->{runtime}{now}+$time*86400;
if($tas eq 'WARNd' or $tas eq 'WARNday' or $tas eq 'WARNtag' or $tas eq 'WARNtage')
{
$lng = " und $user->{nick}'s IP Adresse";
$user->{ipsperr} = 1;
$main->open(local *FILE,'>>'.$main->translateName('vardir::banlist.txt'));
            print FILE "$user->{host}|$user->{ip}|$user->{forwardedfor}|$main->{runtime}{now}|$reason|$user->{name}\n";
            $main->close(*FILE);
}
else
{
$user->{ipsperr} = 0;
}
$taz = 'Tage';
}
elsif($tas eq 'm' or $tas eq 'minuten' or $tas eq 'min' or $tas eq 'minute' or $tas eq 'WARNm' or $tas eq 'WARNminuten' or $tas eq 'WARNmin' or $tas eq 'WARNminute')
{
    $user->{bis_bantime} = $main->{runtime}{now}+$time*60;
if($tas eq 'WARNm' or $tas eq 'WARNminuten' or $tas eq 'WARNmin' or $tas eq 'WARNminute')
{
$lng = " und $user->{nick}'s IP Adresse";
$user->{ipsperr} = 1;
$main->open(local *FILE,'>>'.$main->translateName('vardir::banlist.txt'));
            print FILE "$user->{host}|$user->{ip}|$user->{forwardedfor}|$main->{runtime}{now}|$reason|$user->{name}\n";
            $main->close(*FILE);
}
else
{
$user->{ipsperr} = 0;
}
$taz = 'Minute[n]';
}
elsif($tas eq 'Monat' or $tas eq 'Monate' or $tas eq 'n' or $tas eq 'WARNMonat' or $tas eq 'WARNMonate' or $tas eq 'WARNn')
{
    $user->{bis_bantime} = $main->{runtime}{now}+$time*86400*30;
if($tas eq 'WARNMonat' or $tas eq 'WARNMonate' or $tas eq 'WARNn'){
$lng = " und $user->{nick}'s IP Adresse";
$user->{ipsperr} = 1;
$main->open(local *FILE,'>>'.$main->translateName('vardir::banlist.txt'));
            print FILE "$user->{host}|$user->{ip}|$user->{forwardedfor}|$main->{runtime}{now}|$reason|$user->{name}\n";
            $main->close(*FILE);}else
{
$user->{ipsperr} = 0;
}
$taz = 'Monat[e]';
}
elsif($tas eq 't' or $tas eq 'immer' or $tas eq 'WARNt' or $tas eq 'WARNimmer')
{
    $user->{ban} == 2;
if($tas eq 'WARNt' or $tas eq 'WARNimmer')
{
$user->{ipsperr} = 1;
$lng = " und $user->{nick}'s IP Adresse";
$main->open(local *FILE,'>>'.$main->translateName('vardir::banlist.txt'));
            print FILE "$user->{host}|$user->{ip}|$user->{forwardedfor}|$main->{runtime}{now}|$reason|$user->{name}\n";
            $main->close(*FILE);
}else
{
$user->{ipsperr} = 0;
}
$taz = 'fr immer';
}
else
{
return [$main->createErrorOutput('tas')];
}
    $main->saveUser($user);

my $info = $main->createInfoOutput('ban_add',
          {
          nick => $main->{current_user}{nick},
          admin => $user->{nick},
          ta2 => $taz,
          grund => $reason,
          s => $time,
lng => $lng,
      });
             if($#$candidates == 0)
        {
            my $user = $candidates->[0];
            $main->kickUser($candidates->[0],{error_name => 'error_locked',reason => $reason,nologoutmsg => 1});
my $logout = $main->createInfoOutput('kick_logout',
{
nick => $user->{nick},
});
$logout->restrictToRoom($user->{room});
return [$logout];
}
return [$info];
}
}


sub unban_handler
{
    my($self,$main,$command,$text,$user) = @_;
       my(@parts) = split(/\s/,$text);
    my $nick = shift @parts;
    my $grund = join(' ',@parts);
   my $candidates = $main->getPossibleUsernames($nick);
    return [$main->createErrorOutput('banaddfrage2')] unless defined($nick);
$main->fatal_error('ambiguousname',{nick => $nick}) if ($#$candidates>1);
$main->fatal_error('unknownname',{nick => $nick}) if ($#$candidates<0);
my $user = $main->loadUser($candidates->[0]);
return [$main->createErrorOutput('banadd2_self',{nick => $user->{nick}})] if ($user->{name} eq $main->{current_user}{name});
    $main->loadUser($user->{name},$user);
    $user->{ban} = 0;
    $user->{ban_grund} = '';
    $user->{ban_admin} = '';
    $user->{ban_date} = '';
    $user->{bis_bantime} = '';
$user->{ipsperr} = '';
    $main->saveUser($user);
    $main->open(local *FILE,'+>>'.$main->translateName('vardir::banlist.txt')) || $main->fatal_error('couldnotopen',{file => $main->translateName('vardir::banlist.txt')});
        seek(FILE,0,0);
        my @users=<FILE>;    
        my $min = 0;
        my $max = $#users;    
        while ($min <= $max)
        {
            my $curindex = int(($min+$max)/2);
            my ($curhost,$curip,$curforwardedfor,$curtime,$curreason,$curname) = split(/\|/,$users[$curindex]);
            $curname =~ s/[\n]//g;
            my $result = $curname cmp $user->{name};
            if ($result == 0)
            {
                splice(@users,$curindex,1);
                last;
            }
            elsif ($result < 0)
            {
                $min = $curindex + 1;
            }
            else
            {
                $max = $curindex - 1;
            }
        }
        seek(FILE,0,0);
        truncate(FILE,0);
        print FILE foreach @users;
        $main->close(*FILE);
    my $info = $main->createInfoOutput('unban',
          {
          admin => $main->{current_user}{nick},
          nick => $user->{nick},
      });
        return [$info->restrictToCurrentRoom];
}